<?php
 /*======================================================================*\
|| #################################################################### ||
|| # vt.Lai Url Khong Dau 1.2 For XenForo by SinhVienIT.net           # ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright ©2013 Vu Thanh Lai. All Rights Reserved.               # ||
|| # Please do not remove this comment lines.                         # ||
|| # -------------------- LAST MODIFY INFOMATION -------------------- # ||
|| # Last Modify: 11-08-2013 09:00:00 PM by: Vu Thanh Lai             # ||
|| # Please do not remove these comment line if use my code or a part # ||
|| #################################################################### ||
\*======================================================================*/

class vtLai_UrlKhongDau_Listener
{
	protected static $_routePrefixs=null,$_titleFields=array();
	protected static function _getNewRouteClass()
	{
		$options=XenForo_Application::get('options');
		self::$_routePrefixs=array();
		if($options->vtLaiUrlKhongDauThreadEnable)
		{
			self::$_routePrefixs['XenForo_Route_Prefix_Threads']='vtLai_UrlKhongDau_Threads';
		}
		if($options->vtLaiUrlKhongDauForumEnable)
		{
			self::$_routePrefixs['XenForo_Route_Prefix_Forums']='vtLai_UrlKhongDau_Forums';
		}
		if($options->vtLaiUrlKhongDauCategoryEnable)
		{
			self::$_routePrefixs['XenForo_Route_Prefix_Categories']='vtLai_UrlKhongDau_Categories';
		}
		if($options->vtLaiUrlKhongDauMemberEnable)
		{
			self::$_routePrefixs['XenForo_Route_Prefix_Members']='vtLai_UrlKhongDau_Members';
		}
		if($options->vtLaiUrlKhongDauUserAlbumEnable)
		{
			self::$_routePrefixs['XfRu_UserAlbums_Route_Prefix_UserAlbums']='vtLai_UrlKhongDau_UserAlbums';
		}
		if($options->vtLaiUrlKhongDauXenMedioEnable)
		{
			self::$_routePrefixs['EWRmedio_Route_Media']='vtLai_UrlKhongDau_XenMedio';
		}
		
		if($options->vtLaiUrlKhongDauCustom)
		{
			$vtLaiUrlArr=preg_split('#(\r\n|\n)#',$options->vtLaiUrlKhongDauCustom);
			$i=0;
			foreach($vtLaiUrlArr as &$row)
			{
				if($i>9)
					break;
				if(preg_match('#^(?P<className>[a-z0-9\_]+)\|(?P<titleField>[^\#]+)#i',$row,$m))
				{
					if(isset(self::$_routePrefixs[$m['className']]))
						continue;
					$newClass='vtLai_UrlKhongDau_'.$i;
					self::$_routePrefixs[$m['className']]=$newClass;
					self::$_titleFields[$newClass]=$m['titleField'];
					$i++;
				}
			}
		}
	}
	
	public static function getTitleFields()
	{
		return self::$_titleFields;
	}
	
	
	public static function loadClassRoutePrefix($class, array &$extend)
	{

		if(self::$_routePrefixs===null)
			self::_getNewRouteClass();

		if(isset(self::$_routePrefixs[$class]))
			$extend[]=self::$_routePrefixs[$class];
	}
}